/* 
** 2249a - read out the 12 pedestals of a LeCroy LRS2249A ADC after 
**         generating a test pulse with the test module function.
**         Uses Q-Stop or single word readout mode.
**       
** 11may99 das
** 23may02 das removed unused variables sec, status; added stdlib.h include
**             for exit
**
**/

#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include "timekit.h"

#define NWORDS 12

int main(int argc, char **argv) {

    int	   ext;
    int	   branch;
    int    crate;
    int    slot;
    int	   type;
    int    subad=0;
    int    polllimit=0;
    int    pollcount=0;
    unsigned short dataw[2]={0,0};
    unsigned short data[NWORDS],save_data[NWORDS];

    int	   block[4]={0};
    int	   i,counter;
    int	   qres=0;




    if(argc < 5) {
      printf("Usage: 2249a <branch> <crate> <slot> <type: serial=0,parallel=1>\n");
      return 0;
    }  


    if(argc > 1)
	sscanf(argv[1],"%d",&branch);

    if(argc > 2)                           
        sscanf(argv[2],"%d",&crate);

    if(argc > 3)
	sscanf(argv[3],"%d",&slot);

    if(argc > 4)                           
        sscanf(argv[4],"%d",&type);

    /* open the SCSI device */
    if((cdchn(branch,1,0) &1) != 1){
	perror("cdchn error");
	exit(2);
	}

    /* set the controller type */
    if(type == 0)
	ccctype(branch,1,0); /* serial */
    else
        ccctype(branch,0,1); /* parallel - Jor 73A is considered parallel */


    /* encode the branch, crate, slot, 
       and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);

    /* crate clear */
    cccc(ext);
    /* crate initialize */
    cccz(ext);
    /* remove crate inhibit */
    ccci(ext,0);

    for(i=0;i++;i<12){save_data[i]=0;}

    counter=0;

    while(1){

      counter++;
      if( counter%100==0 ) printf("\n Counter= %d",counter);

    /* clear 2249A  */
    cssa(9,ext,dataw,&qres);

    block[0]=NWORDS;   /* set the transfer size */

    /* poll for LAM */
    polllimit=100000;
    pollcount=0;

    cssa(8,ext,dataw,&qres);
    while(!qres) {
      for (i=0; i<5000; i++){};
      cssa(8,ext,dataw,&qres);
      pollcount++;
      if(pollcount==polllimit){
	printf("\n Poll count reached limit");
	return 1; }
    }

    /* readout loop */

      for (subad=0; subad<11; subad++) {
	  cdreg(&ext,branch,crate,slot,subad);
	  cssa(2,ext,&data[subad],&qres);
	  if (!qres){
	    printf ("\n No Q from slot %d sub-address %d",slot,subad);
	    return 1;}
	  if(abs(data[subad]-save_data[subad])>15){
	    printf("\n Large ped diff:\n       Counter, channel, old, new = %d %d %d %d",counter,subad,
		   save_data[subad],data[subad]);
	    printf("\n    Difference = %d",data[subad]-save_data[subad]);}
	  save_data[subad]=data[subad];
      }

    }

    return 0;
}













