// reads tup data from      assigned to link inNtuple
// writes ascii tuple file: ntuple.ascii using nout
#include <iostream>
#include <iomanip>
#include <fstream>		// needed by  ofstream to open output file
#include "histogram.h"
#include <string>
#include <unistd.h>

#define DEBUG 0
#define DEBUG2 1

#define TAB '\t'

using namespace std;
 
unsigned  getbits( unsigned x, unsigned p, unsigned n)
{
    /* get n bits from position p */
        return  (( x >> (p+1-n)) & ~(~0 << n));
}


int main(int argc, char** argv)	{

	string titleString;

	int fileLineCount=0;
	int nRunNumber, runType, nEventCount, bufferSequenceNumber, nRealTimeLR1, nRealTimeHR1;
	int nADC1time, nADC2time, nADC3time, nADC2ph, nScalerValue[4];
	int nADC3ph, nADC4ph, nADC5ph, nADC6ph;
	int nadc1, nadc2, nadc3, nadc4, nadc5;
	int ntupleCount;                                                                                                                                          
	int eventCount=0;
	int ntupleInCount=0;
	int ntupleOutCount=0;
	int scaler1Total[4]={0,0,0,0};
	int nScaler1Old[4]={0,0,0,0};
	int i;
	float alim=0.0, blim=16384.0;
	//	alim= 0.0; blim = 4000;
	//	alim=3000.0, blim=7000.0;	// trigger1
	//	alim=2060.0; blim=2100.0;
	histogram *hADCtime1 = new histogram( alim, blim, "h time ADC TAC 1 data ");
	//	alim=1850.0; blim=1890.0; 
	histogram *hADCtime2 = new histogram( alim, blim, "h time ADC TAC 2 data ");
	histogram *hADCtime3 = new histogram( alim, blim, "h time ADC TAC 3 data ");

		blim=20.0;
	histogram *hADC3minus2 = new histogram (-blim,blim,"h time difference mcp 3 - mcp 4 ");

	float tac1m=2100.;
	float tac2m=2879.;
	float tac3m=2740.;
	float hw= 2*10.0;
	histogram *hTAC1fs = new  histogram( tac1m-hw, tac1m+hw, "h TAC 1 fine scale for pulser data ");
	histogram *hTAC2fs = new  histogram( tac2m-hw, tac2m+hw, "h TAC 2 fine scale for pulser data ");
        	hw=3*10.0;
	histogram *hTAC3fs = new  histogram( tac3m-hw, tac3m+hw, "h TAC 3 fine scale for pulser data ");

	 alim=0.0; blim=1024.;
	
	 histogram *hpm1 = new histogram(alim, blim, "h ph ADC 1 data ");
	 histogram *hpm2 = new histogram(alim, blim, "h ph ADC 2 data ");
	 histogram *hpm3 = new histogram(alim, blim, "h ph ADC 3 data ");
	 histogram *hpm4 = new histogram(alim, blim, "h ph ADC 4 data ");
	 histogram *hpm5 = new histogram(alim, blim, "h ph ADC 5 data ");

	 float pm1m=520.;
	 float pm2m=650.;
	 	hw=5.0*10.0;
	 //histogram *hpm1fs = new histogram(pm1m-hw,pm1m+hw, "h ph ADC 1 data pulser fine scale");
	 //histogram *hpm2fs = new histogram(pm2m-hw,pm2m+hw, "h ph ADC 2 data pulser fine scale");
	 histogram *hpm1fs = new histogram(0,400, "h ph ADC 1 data pulser fine scale");
	 histogram *hpm2fs = new histogram(0,400, "h ph ADC 2 data pulser fine scale");
	 histogram *hpm3fs = new histogram(0,400, "h ph ADC 3 data pulser fine scale");
	 histogram *hpm4fs = new histogram(0,400, "h ph ADC 4 data pulser fine scale");
	 histogram *hpm5fs = new histogram(0,400, "h ph ADC 5 data pulser fine scale");

	int slowRampValue, fastRampValue;
//	adc is 10 bits so max is 1024
	 histogram *hSlowRamp = new histogram(0.0, 600.0 , "h Slow Ramp data ");
	 histogram *hFastRamp = new histogram(0.0, 600.0 , "h Fast Ramp data ");

	//cout << "Enter Run Description parameters: " << endl;
	//cout <<"runNumber  pulserDelay  pulserPeriod " << endl;
	//cin >> runNumber >> pulserDelay >> pulserPeriod;


	ifstream in("inNtuple");
	if ( !in ) {
		cout << "Cannot open input file. Exit with error. \n";
     		return 1;
   	}



	// 1st line is text not data
	getline(in,titleString);
	fileLineCount++;
	
	cout << "Title: " << titleString << endl;
	cout << "DEBUG:\tLine\tlineID\thdata\tddata" << endl;

   // open an output stream to make file of ascii nutples for ROOT
/*
   ofstream nout("ntuple.ascii.output");
   if(!nout)
   {
     cout << "Cannot open output file.\n";
     return 1;
   }
	// output column names
	nout << "RunNum"<<TAB<<"RunTyp"<< TAB<< "EvntNum" <<TAB<< "BufSeqN" 
			<<TAB<<"RealTimeLR"<<TAB<< "RTimHR"
			<<TAB<<"LrRamp" <<TAB<<"HrRamp"
			<<TAB<<"TAC1Tim"<<TAB<< "TAC2Tim" <<TAB<<"TAC3Tim"
			<<TAB<<"Dev1Ph" <<TAB<<"Dev2Ph" 
	                <<TAB<<"Scaler1"<<TAB<<"Scaler2"<< TAB <<"Scaler3"
			<<endl;
 */

   for (;;) {

// old format
/*
	in >> nRunNumber    >> runType      
	>> nEventCount   >> bufferSequenceNumber 
	>> nRealTimeLR1  >> nRealTimeHR1 
	>> slowRampValue >> fastRampValue
	>> nADC1time     >>  nADC2time >> nADC3time 
	>> nADC2ph       >>  nADC3ph 
	>> nScalerValue[1] >> nScalerValue[2] >> nScalerValue[3] ;
 */
// new format 
	in >> runType >> nRunNumber 
	>> bufferSequenceNumber >> nEventCount
	>> nScalerValue[1] >> nScalerValue[2] >> nScalerValue[3]
	>> slowRampValue >> fastRampValue
	>> nadc1       >>  nadc2
	>> nADC1time     >>  nADC2time >> nADC3time
	>> nadc3       >>  nadc4   >> nadc5
	>> nRealTimeHR1  >> nRealTimeLR1 ;
// runType runNum  blkCnt  tuplNum scaler1 scaler2 scaler3 ramp1   ramp2   adc1    adc2    tac1    tac2    tac3    hrClock lrClock

	// detect an EOF
        if ( in.eof() != 0 ) {
                cout << "Found end of file..." << endl;
                break;
        }
	ntupleInCount++;
	for ( i=1; i<4; i++ ){
		if ( nScalerValue[i] != nScaler1Old[i] ) {
			scaler1Total[i] = scaler1Total[i] + nScalerValue[i];
			nScaler1Old[i]= nScalerValue[i];
		}
	}	


	fileLineCount++;
	if ( fileLineCount < 100 ) {
			cout << nRunNumber    <<TAB<< runType      
			<<TAB << nEventCount  <<TAB<< bufferSequenceNumber 
			<<TAB<< nRealTimeLR1  <<TAB<< nRealTimeHR1 
			<<TAB<< slowRampValue <<TAB<< fastRampValue
			<<TAB<< nADC1time     <<TAB<<  nADC2time <<TAB<< nADC3time 
			<<TAB<< nADC2ph       <<TAB<<  nADC3ph 
			<<TAB<< nScalerValue[1] <<TAB<< nScalerValue[2] <<TAB<< nScalerValue[3] 
	                << endl;
	}
	eventCount++;
	hADCtime1->update( (float) nADC1time );
	hADCtime2->update( (float) nADC2time );
	hADCtime3->update( (float) nADC3time );
	hpm1->update( (float) nadc1 );
	hpm2->update( (float) nadc2 );
	hpm3->update( (float) nadc3 );
	hpm4->update( (float) nadc4 );
	hpm5->update( (float) nadc5 );
	hTAC1fs->update( (float) nADC1time );
	hTAC2fs->update( (float) nADC2time );
	hTAC3fs->update( (float) nADC3time );
	hpm1fs->update( (float) nadc1 );
	hpm2fs->update( (float) nadc2 );
	hpm3fs->update( (float) nadc3 );
	hpm4fs->update( (float) nadc4 );
	hpm5fs->update( (float) nadc5 );

	hFastRamp->update( (float) fastRampValue );

	// make selection on ntuple read in
/* old format
	if ( nADC1time != 0 && nADC2time != 0 && nADC3time != 0 ) {
		nout << nRunNumber    <<TAB<< runType      
		<<TAB << nEventCount  <<TAB<< bufferSequenceNumber 
		<<TAB<< nRealTimeLR1  <<TAB<< nRealTimeHR1 
		<<TAB<< slowRampValue <<TAB<< fastRampValue
		<<TAB<< nADC1time     <<TAB<<  nADC2time <<TAB<< nADC3time 
		<<TAB<< nADC2ph       <<TAB<<  nADC3ph
		<<TAB<< nScalerValue[1] <<TAB<< nScalerValue[2] <<TAB<< nScalerValue[3] 
                << endl;
		ntupleOutCount++;
	}
 */
   } // end of forever

	// output histograms.
	hADCtime1->printLong();
	hADCtime2->printLong();
	hADCtime3->printLong();
	//hADC3minus2->printLong();

	hTAC1fs->printLong();
	hTAC2fs->printLong();
	hTAC3fs->printLong();

	hpm1->printLong();
	hpm2->printLong();
	hpm1fs->printLong();
	hpm2fs->printLong();

	//hSlowRamp->printLong();
	//hFastRamp->printLong();


	cout << endl;
	cout << "fileLineCount = " << fileLineCount << endl;
	cout << "ntupleInCount     = " << ntupleInCount << endl;
	cout << "ntupleOutCount     = " << ntupleOutCount << endl;
	cout << "ADCtime1 count/mean/stdev = " << hADCtime1->get_sumIn() << TAB << hADCtime1->mean() << TAB << hADCtime1->stdev() << endl;
	cout << "ADCtime2 count/mean/stdev = " << hADCtime2->get_sumIn() << TAB << hADCtime2->mean() << TAB << hADCtime2->stdev() << endl;
	cout << "ADCtime3 count/mean/stdev = " << hADCtime3->get_sumIn() << TAB << hADCtime3->mean() << TAB << hADCtime3->stdev() << endl;
	cout << "TAC1fs count/mean/stdev = " << hTAC1fs->get_sumIn() << TAB << hTAC1fs->mean() << TAB << hTAC1fs->stdev() << endl;
	cout << "TAC2fs count/mean/stdev = " << hTAC2fs->get_sumIn() << TAB << hTAC2fs->mean() << TAB << hTAC2fs->stdev() << endl;
	cout << "TAC3fs count/mean/stdev = " << hTAC3fs->get_sumIn() << TAB << hTAC3fs->mean() << TAB << hTAC3fs->stdev() << endl;
	cout << "TAC1 efficiency fraction = " << ( (float) hADCtime1->get_sumIn())/eventCount << endl;
	cout << "TAC2 efficiency fraction = " << ( (float) hADCtime2->get_sumIn())/eventCount << endl;
	cout << "TAC3 efficiency fraction = " << ( (float) hADCtime3->get_sumIn())/eventCount << endl;

	cout << "ADC1ph count/mean/stdev = " << hpm1->get_sumIn() << TAB << hpm1->mean() << TAB << hpm1->stdev() << endl;
	cout << "ADC2ph count/mean/stdev = " << hpm2->get_sumIn() << TAB << hpm2->mean() << TAB << hpm2->stdev() << endl;
	cout << "ADC1ph fs  count/mean/stdev = " << hpm1fs->get_sumIn() << TAB << hpm1fs->mean() << TAB << hpm1fs->stdev() << endl;
	cout << "ADC2ph fs  count/mean/stdev = " << hpm2fs->get_sumIn() << TAB << hpm2fs->mean() << TAB << hpm2fs->stdev() << endl;

	cout << "Scaler ch 1 (raw trigger)    = " << scaler1Total[1] << endl;
	cout << "Scaler ch 2 (master trigger) = " << scaler1Total[2] << endl;
	cout << "Scaler ch 3 (FERA tokens)    = " << scaler1Total[3] << endl;
	cout << "End of event builder and ntuple writer." << endl;
	cout << endl;

	// nout.close();

	return 0;

}
