#!/bin/bash

#This script is intented to run everything that has to be done when acquiring data.
#It writes environmental variables (temperature, ...) to the database, then runs the acquisition, generates an ntuple for the nearline analysis, and at last re-writes environmental variables to the database.

#Written by Emilien Chapon, June 5 2008
#Modified Thu Jun  5 18:04:35 CDT 2008 Ed May
#Modified Fri Jun  6 19:00 Ed May	test with series of runs

#First, set the run number. For that we read the previous run number from the database, provided it already exists.
if test -f database.db ;
then
	RUN_NUMBER=$(tail -n 1 database.db | sed -e 's/ .*//')
else
	echo "warning, couldn't find the database, creating a new one"
	RUN_NUMBER=100
fi


#First read of parameters before the run
echo "Beginning of run $RUN_NUMBER, now ($(date '+%T %D')) retrieving beam environment parameters and writing them to the database"
#Check if the database is blocked
while test -f databse.db.lock ; do
	echo 'warning, database is locked'
	sleep 1
done
echo > database.db.lock
echo -e $RUN_NUMBER '\t' 0 '\t' $(date '+%T') '\t' $(date '+%D') '\t' $(date '+%s') '\t' $(exec acread2 I:Beam) '\t' $(exec acread2 'F:MW1SEM') '\t' $(exec acread2 'F:MC1SEM') '\t' $(exec acread2 'F:MC6IC') '\t' $(exec acread2 'F:MT6TP1') '\t' $(exec acread2 'F:MT6TP2') '\t' $(exec acread2 'F:MT6SC1') '\t' $(exec acread2 'F:MT6SC2') >> database.db
rm database.db.lock
echo wrote the following line to database:
tail -n 1 database.db


echo End of script
