#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

/* use below to get rid of warning message */
void usleep(unsigned long usec);


int main()
{
  int ext;
  int branch=18;
  int crate=4;
  int slot,subad;

  int return_status = CAM_S_SUCCESS;


 	
  /****************** OPEN Jorway CAMAC interface **********************/

  printf ("\n Opening Jorway411 branch highway");
  
  if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
    printf("Error opening branch=%d\n",branch);
    exit(1);
  };
  
  ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */
  
  /**************************** Initialize CAMAC **************************/
  
  printf("\n Initializing CAMAC\n");
  slot=2; subad=0; 
  
  /* encode the branch, crate, slot, 
     and subad arguments into ext */
  cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
  cccc(ext);
  /* crate initialize */
  cccz(ext);
  /* remove crate inhibit */
  ccci(ext,0);

  printf("\nCrate clear,init and remove inhibit is done.\n ");

  
  slot=2; subad=0; crate = 5;
  
  /* encode the branch, crate, slot, 
     and subad arguments into ext */
  cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
  cccc(ext);
  /* crate initialize */
  cccz(ext);
  /* remove crate inhibit */
  ccci(ext,0);
  printf("\n\n***** Done  *****\n\n");
  
  return 0;
}
