// reads raw data from run_xxx.txt assigned to link indata
// writes ascii tuple file: ntuple.ascii using nout
#include <iostream>
#include <iomanip>
#include <fstream>		// needed by  ofstream to open output file
#include "histogram.h"
#include <string>

#define TAB '\t'

using namespace std;
 
unsigned  getbits( unsigned x, unsigned p, unsigned n)
{
    /* get n bits from position p */
        return  (( x >> (p+1-n)) & ~(~0 << n));
}


int main(int argc, char** argv)	{

	int i;
	int lineID, hdata, ddata;
	int feraID;
	int lineTotalLineCount = 0;
	int fileLineCount = 0;
	int linesInChunk=0;
	int bufferNumber=0, bufferCount=0;
	string titleString;
	int ptrToNext=1;
	bool notTheFirst=false, ptrData=false, firstTime = true ;
	bool ad114Header1 = false;
	bool ad114Header2 = false;
	int ad114Header1Count=0;
	int ad114Header2Count=0;
	int ntupleCount=0;
	//unsigned int event[18];
	unsigned int event[28];
	int errorType1count = 0;
	int nRunNumber=0, nEventCount=0;
	int nADC1time = 0, nADC2time = 0,  nADC1ph = 0, nADC2ph = 0;

#define N21
#define EVSIZE 21
#define ADCLOC 0
#define AD1LOC  17
#define AD2LOC  19

/*
#define N19
#define EVSIZE 19
#define ADCLOC 0
#define AD1LOC  17
#define AD2LOC  -1
 */

/*	definintions for N21
	0	ladc header		8004
	1	adc channel 0
	...
	15	adc channel 14
	16	adc channel 15
	17	AD114 header		8801
	18	AD114 data
	19	AD114 header		8802
	20	AD114 data		
 */
	int inIndex[EVSIZE], inHdata[EVSIZE], inDdata[EVSIZE];
	int indexEv=0;
	int countADCheader=0, countTDCheader=0;
	int countAD114header1=0, countAD114header2=0;
	int lineCount=0, eventCount=0;
	int lAdcChAddr[16], lAdcChData[16];

	float mADCtime1 = 3050.0;
	float lADCtime1 = 500.0;
	//histogram *hADCtime1 = new histogram( mADCtime1-lADCtime1, mADCtime1+lADCtime1, "h time ADC 1 data ");
	histogram *hADCtime1 = new histogram( 0.0, 5000.0, "h time ADC 1 data ");
	float mADCtime2 = 1850.0;
	float lADCtime2 = 500.0;
	//histogram *hADCtime2 = new histogram( mADCtime2-lADCtime2, mADCtime2+lADCtime2, "h time ADC 2 data ");
	histogram *hADCtime2 = new histogram( 0.0, 5000.0, "h time ADC 2 data ");

	 histogram *hADCpm1 = new histogram(0.0, 400.0, "h ph ADC 1 data ");
	 histogram *hADCpm2 = new histogram(0.0, 400.0, "h ph ADC 2 data ");

	//cout << "Enter Run Description parameters: " << endl;
	//cout <<"runNumber  pulserDelay  pulserPeriod " << endl;
	//cin >> runNumber >> pulserDelay >> pulserPeriod;


	ifstream in("indata");


	// 1st line is text not data
	//getline(in,titleString);
	//fileLineCount++;
	
	cout << "Title: " << titleString << endl;
	cout << "DEBUG:\tLine\tlineID\thdata\tddata" << endl;

   // open an output stream to make file of ascii nutples for ROOT
   ofstream nout("ntuple.ascii");
   if(!nout)
   {
     cout << "Cannot open output file.\n";
     return 1;
   }
	// output column names
	nout << "RunNumber"<<TAB<<"EventNumber"<<TAB<<"Adc1Time"<<TAB<<"Adc2Time"<<TAB<<"Adc1Ph"<<TAB<<"Adc2Ph"<<endl;


   for (;;) {
	
	lineCount++;
	indexEv = (lineCount - 1)%EVSIZE;

	in >> inIndex[indexEv] >> hex >> inHdata[indexEv] >> dec >> inDdata[indexEv];
	if ( lineCount <= 32 ) cout<<"Line: "<< lineCount << TAB << indexEv << TAB 
			<< inIndex[indexEv] << TAB << hex << inHdata[indexEv] << TAB<<dec << inDdata[indexEv]
			<< endl;
	if ( inHdata[0] == 0 && lineCount == 1) countADCheader++;	/* kludge to get sums correct */

	if ( indexEv == 0 && lineCount !=1 ) {

		int LeCroyADCheader = 0x8004;
		    LeCroyADCheader = 0x8005;	/* did this change */

		if ( inHdata[ADCLOC] != LeCroyADCheader ) {	/* lecroy 4300 ADC header */
			cout << "at line = "<<  lineCount <<  " ADC Alignment error..." << endl;
			return 1;
		} else {
			countADCheader++;
		}
                if ( inHdata[AD1LOC] != 0x8801 ) {
                        cout << "ad114 Alignment error on 8801..." << endl;
                } else {
                        countAD114header1++;
                        nADC1time = inHdata[AD1LOC+1];
                }
#ifdef N21
                if ( inHdata[AD2LOC] != 0x8802 ) {
                        cout << "ad114 Alignment error on 8802..." << endl;
                } else {
                        countAD114header2++;
                        nADC2time = inHdata[AD2LOC+1];
                }
#endif

		eventCount++;
		for ( i=0; i<16; i++ ) {
			lAdcChAddr[i] = getbits(inHdata[ADCLOC+1+i],15,5);
			lAdcChData[i] = getbits(inHdata[ADCLOC+1+i],10,10);
		}
		
			hADCtime1->update( (float) inHdata[AD1LOC+1] );
			hADCtime2->update( (float) inHdata[AD2LOC+1] );
		hADCpm1->update( (float) lAdcChData[0] );
		hADCpm2->update( (float) lAdcChData[15] );
		if ( eventCount < 10 ) {
			/*
			cout << " " << lAdcChAddr[0] << " " << lAdcChData[0];
			cout << " " << lAdcChAddr[15] << " " << lAdcChData[15];
			*/
			for ( i=0; i<16; i++ ) {
				cout << " " << lAdcChAddr[i] 
				<< " " << lAdcChData[i];
			}
			cout << endl;
		}
		// begin building ntuple to outup
		nADC1ph = lAdcChData[0];
		nADC1ph = lAdcChData[15];
		nEventCount = eventCount;
		nout << nRunNumber << TAB<< nEventCount <<TAB<< nADC1time <<TAB<< nADC2time <<TAB<< nADC1ph <<TAB<< nADC1ph << endl;
	}

		

	// detect an EOF
	if ( in.eof() != 0 ) {
		cout << "Found end of file..." << endl;
		break;
	}

           //ixbin=khist( (double) x, alow, ahgh, 16);
	   // histogram X distribution for all ntuples
   } // end of forever loop

	// output histograms.
	hADCtime1->printLong();
	hADCtime2->printLong();
	hADCpm1->printLong();
	hADCpm2->printLong();
	cout << endl;
	cout << "Found " << lineCount << " lines."  << endl;
	cout << "eventCount      = " << eventCount << endl;
	cout << "errorType1count = " << errorType1count << endl;
	cout << "countADCheader = " << countADCheader << endl;
	cout << "countAD114header1 = " << countAD114header1 << endl;
	cout << "countAD114header2 = " << countAD114header2 << endl;
	cout << "ntupleCount     = " << ntupleCount << endl;

	nout.close();

	return 0;

}
