#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/* use below to get rid of warning message */
void usleep(unsigned long usec);

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  /*int ret;	*/	/* return for CAMAC command*/
  int mPointer=0;	/* holder for FERA memory pointer returned */
  int ext;
  int branch=18;
  int crate1=4;
  int crate,slot,subad,function,qres;

  /* unsigned long CDATA,CDATA0,CDATA1,CDATA2,CDATA3; */

  int return_status = CAM_S_SUCCESS;
  /* data array returned by Camac Controler */
  /* unsigned short IntArray[10000]; 
   */
  unsigned short dataw[2]={0,0};
  unsigned short data16[32768];
  unsigned long  dataw24[2]={0,0};
  /* Jorway spec say max 16bit word dma transfer is 16100 */
  int cb[3];	/* camac control block 0=request_repeat_count 1=result_repeat_count
					2=lam id(not used)    3=dma type 0=Q-stop 1=single_word
                         */
  int i=0;
  int evLoop=0,evLoopMax=0, iWait=0, iPulse=0;
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */
  
 	
 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    crate = 4;
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
/*    cccc(ext);		*/
  /* crate initialize */
/*    cccz(ext);		*/
  /* remove crate inhibit */
    ccci(ext,0);

  function=0;

  /*******   ****/
	slot=21;
	
/*
	subad = 0;
	dataw[0]=0xFFFF;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(16,ext,dataw,&qres);
	printf("F16A0 read: 0x%X Q=%d\n", dataw[0], qres);
 */
	
	for ( i=0; i<4; i++) {
	subad = i;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(0,ext,dataw,&qres);
	printf("F0A%d preread: 0x%X %d Q=%d\n", i, dataw[0], dataw[0], qres);
	}


	return 1;
	

	printf("sleep for 1 second.\n");
	sleep(1);
	int iMax=   200000;
	printf("Ask for iMax = %d 0x%X \n", iMax, iMax);
	for (i=0; i<iMax; i++)	{
		subad = i;
		subad = 0;
        	cdreg(&ext,branch,crate1,slot,subad);
        	cssa(25,ext,dataw,&qres);
        	if ( qres !=0) printf("F25A%d test: 0x%X Q=%d\n", i, dataw[0], qres);
	}

	
	for ( i=0; i<4; i++) {
	 subad = i;
	 cdreg(&ext,branch,crate1,slot,subad);
	 cfsa(0,ext,dataw24,&qres);						/* 24 bit read */
	 printf("F0A%d 24 bit read: 0x%X %d Q=%d\n", i, dataw24[0], dataw24[0], qres);
	}


/*	clear all four channels */
	for ( i=0; i<4; i++) {
	 subad = i;
	 cdreg(&ext,branch,crate1,slot,subad);
	 cssa(9,ext,dataw,&qres);
	 printf("F0A%d clear: 0x%X Q=%d\n", i, dataw[0], qres);
	}
	

	printf("sleep for 1 second.\n");
	sleep(1);

	printf("10 iterations of read and sleep for 1 sec.\n");
	for ( i=0; i<10; i++) {
         subad = 0;
         cdreg(&ext,branch,crate1,slot,subad);
         cssa(0,ext,dataw,&qres);
         printf("F0A%d read: 0x%X %d Q=%d\n", i, dataw[0], dataw[0], qres);
	 sleep(1);
	}
	
	
	


    printf("\n\n***** End of DAQ *****\n\n");
    fprintf(stderr, "\n\n***** End of DAQ *****\n\n");

    return 0;
}
