#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  /*int ret;	*/	/* return for CAMAC command*/
  int ext;
  int branch=18;
  int crate1=2;
  /*
  int crate2=4;
   */
  int crate,slot,subad,function,temp,qres;
  
  /* unsigned long CDATA,CDATA0,CDATA1,CDATA2,CDATA3; */

  int return_status = CAM_S_SUCCESS;
  /* data array returned by Camac Controler */
  /* unsigned short IntArray[10000]; 
   */
  unsigned short dataw[2]={0,0};
  unsigned short data16[32768];
  /* Jorway spec say max 16bit word dma transfer is 16100 */
  int cb[3];	/* camac control block 0=request_repeat_count 1=result_repeat_count
						2=lam id(not used)    3=dma type 0=Q-stop 1=single_word
                         */
  int i=0;
  /*
  unsigned short RAW;
  int numNoReads=25;
  float pulserDelay=0.0, pulserPeriod=0.0;
   */
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */
  
 	
  /***************** OPEN DATA FILE ********************/

	/* File to save data */
/*
    FILE *data_file;
    char file[20] = ("data/run_001.txt");
    char ctemp[4];
    int r;
    int run;
 */

  /* get configuration information from user or a <redirected file. */
/*   printf("Enter Run Number:  ");
    scanf("%003i",&run);
    printf("run = %d\n", run);
    sprintf( &ctemp[0], "%03i", run);
    for (r = 0; r<3; ++r) file[r+9]=ctemp[r];
    printf("file name = %s\n", file); */

  /* Truncate to zero length or create file for writing ascii data output*/
    /*    data_file = fopen(file,"w");
    if ( data_file == NULL ) {
      printf("Failed to open an output file to write data!\n");
      return 2;}

    printf("Enter Number of NoReads allowed: ");
    scanf("%d",&numNoReads);
    printf("Enter pulserDelay: ");
    scanf("%f",&pulserDelay);
    printf("Enter pulserPeriod: ");
    scanf("%f",&pulserPeriod);

    printf("User requested numNoReads = %d\n", numNoReads);
    printf("User requested pulserDelay = %f\n", pulserDelay);
    printf("User requested pulserPeriod = %f\n", pulserPeriod);

    printf("TitleLine: CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", 
    run, numNoReads, pulserDelay, pulserPeriod);
    fprintf(data_file,"CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", 
    run, numNoReads, pulserDelay, pulserPeriod);

    */


 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
    cccc(ext);
  /* crate initialize */
    cccz(ext);
  /* remove crate inhibit */
    ccci(ext,0);

  function=0;

  /****************** SET UP 1st Ortec AD411 ADC ***********************/
  /*	0x5F00 = 1001 1111 0000 0000

	B16 =1 => Overflow-suppresion
	B13 =1 => Singles mode
	B12 =1 => Master Gate ignored
	B11 =1 => Local Gate ignored
	B10 =1 => Camac readout enabled
	B9  =1 => Zero-suppression ? ? ?  */
 
    printf("\n Initializing ADC1");

  /* Clear module */
    slot=8; subad=0; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);

  /* Write to control register and read back  */
    dataw[0]=0x1801;    
    cssa(16,ext,dataw,&qres);  /* Using FERA */

    cssa(0,ext,&dataw[0],&qres);  
    printf("\n ADC1 Control Register: 0x%x", dataw[0]);	

  /* Read lower level discriminator setting */
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 LLD: 0x%x", temp & 0xFF);	

  /* Read upper level discriminator setting */
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 ULD: 0x%x", dataw[0] & 0xFF);	
    printf("\n");

  /****************** SET UP 2nd Ortec AD411 ADC ***********************/
 
    printf("\n Initializing ADC2");

  /* Clear module */
    slot=3; subad=0; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);

  /* Write to control register and read back  */
    dataw[0]=0x1402;    
    cssa(16,ext,dataw,&qres);  /* Using FERA */

    cssa(0,ext,&dataw[0],&qres);  
    printf("\n ADC2 Control Register: 0x%x", dataw[0]);	

  /* Read lower level discriminator setting */
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC2 LLD: 0x%x", dataw[0] & 0xFF);	

  /* Read upper level discriminator setting */
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC2 ULD: 0x%x", dataw[0] & 0xFF);	
    printf("\n");

  /***************** SET UP the LeCroy 4302 FERA memory ********************/

    printf("\n Initializing 4302 buffer memory");

    slot=14; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/

    dataw[0]=0x1;
    cssa(26,ext,dataw,&qres);    /* Set 4302 to enable LAM*/

    slot=14; subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address */

    slot=14; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x3;
    cssa(17,ext,dataw,&qres);    /* Set 4302 ECL mode enabled */

    cssa(1,ext,&dataw[0],&qres);    /* Read mode */
    printf("\n 4302 buffer mode is = %X",dataw[0]);

    printf("\n");

  /****************** SET UP Lecroy 4300B  ADC **********************/

    printf("\n Initializing 4300 ADC");

    slot=5; subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres); 

    dataw[0]=0x0404;
    cssa(16,ext,dataw,&qres); 

    cssa(0,ext,&dataw[0],&qres); 
    printf("\n 4300 control register = %X",dataw[0]);

    printf("\n");

  /****************** SET UP Lecroy 3377 TDC **********************/

    slot=10; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(24,ext,dataw,&qres);   /* Disable acquisition*/

    slot=10; subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);   /* Initial clear */
    cssa(30,ext,dataw,&qres);  /* Enable programming */
    cssa(25,ext,dataw,&qres);  /* Begin programming */
    qres=0;
    while(qres!=1){cssa(13,ext,dataw,&qres);} /* Test for programming done */

    cssa(9,ext,dataw,&qres);   /* Initial clear */

    cssa(1,ext,&dataw[0],&qres);   
    printf("\n Mode = %d",(dataw[0]&&0xC000)>>14);

    dataw[0]=0x0803;    /* Header mode; .5 nsec; FERA; leading edge */
    cssa(17,ext,dataw,&qres);   /* Control register 0 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 0 = %X",dataw[0]);

    slot=10; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x02FF;        /* Clock unit=100nsec; delays 1.5 microsec */
    cssa(17,ext,dataw,&qres);   /* Control register 1 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 1 = %X",dataw[0]);

    slot=10; subad=2;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x03D1;            /* 488 nsec full scale  */
    cssa(17,ext,dataw,&qres);   /* Control register 2 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 2 = %X",dataw[0]);

    slot=10; subad=3;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x000F;            /* REQ delay of 30 microsec */
    cssa(17,ext,dataw,&qres);   /* Control register 3 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 3 = %X",dataw[0]);

    slot=10; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(26,ext,dataw,&qres);   /* Enable acquisition */

    printf("\n\n***** End of setup and configuration ******\n");


/* possible beginning of polling loop */


	printf("sleeping for 10 seconds...\n");
	sleep(10);	/* waiting till memory fills...*/


  /* set crate inhibit */
/*
    ccci(ext,1);
 */

    /* Set 4302 to CAMAC mode*/
    slot=14; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/

    /* Set 4302 current memory address to 0 */
    slot=14; subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to 0 */

    /* do a 1 word read or dma of 4302 memory */
    if ( 1 == 0 ) {
	slot=14; subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(0, ext, &dataw[0], &qres);
	printf("1st word in memory is %X %d \n", dataw[0], dataw[0]);
    } else {
	slot=14; subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	cb[0]=16100; cb[1]=0; cb[2]=0; cb[3]=0;
	csubc(0, ext, data16, cb);
	printf("dma returns cb[1]=%d\n", cb[1]);
	int top = cb[1];
	if (top > 16384 ) top = 16384;
	for ( i=0; i<top; i++) 
		printf("i=%d data16[%d]= %x %d \n", i,i,data16[i],data16[i]);
    }

    /* Set 4302 current memory address to 0 */
    slot=14; subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to 0 */

    /* Set 4302 ECL mode enabled */
    slot=14; subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x3;
    cssa(17,ext,dataw,&qres);    /* Set 4302 ECL mode enabled */


  /* remove crate inhibit */
    ccci(ext,0);

/* possible end of polling loop */

    printf("\n\n***** End of DAQ *****\n\n");
	
  /* At end freeze DAQ with */
  /* set crate inhibit */
/*
    ccci(ext,1);
 */

    printf("\n\n***** Normal END *****\n\n");

    return 0;
}
