
{
//   example of macro to read data from an ascii file and
//   create a root file with an histogram and an ntuple.
   gROOT->Reset();
#include "Riostream.h"

   ifstream in;
// this file has the correct number of  columns of integer data
   in.open("ntuple.ascii");

   Int_t nlines=0;


   // places to hold data readin
   Int_t runType,runNum, blkCnt,tuplNum,scaler1,scaler2,scaler3,ramp1,ramp2;
   Int_t adc1,adc2,tac1,tac2,tac3,hrClock,lrClock;

   //TFile *f = new TFile("PSECpulserData.root","RECREATE");
   TH1F *h1adc1 = new TH1F("h1adc1"," adc1 distribution",100,0,1024);
   TH1F *h1adc2 = new TH1F("h1adc2"," adc2 distribution",100,0,1024);
   TH2F *h2adc1v2 = new TH2F("h2adc1v2"," adc1 v adc2 ", 40,0,1024,40,0,1024);
   TH1F *h1adc1a = new TH1F("h1adc1a"," adc1 distribution",100,150,350);
   TH1F *h1adc2a = new TH1F("h1adc2a"," adc2 distribution",100,150,350);
   TProfile *hpr1v2 = new TProfile("hpr1v2","Profile of adc2 v adc1",100,150,350,150,350);
   TH1F *h1t1 = new TH1F("h1t1"," tac1 distribution",100,0,12000);
   TH1F *h1t1a = new TH1F("h1t1a"," tac1 distribution",100,2000,2200);
   TH1F *h1t1b = new TH1F("h1t1b"," tac1 distribution",100,9000,10000);
   
   // build a root ntuple with only usual quantities
   //TNtuple *ntuple = new TNtuple("ntuple","data from ascii file",
   //                              "runNum:tuplNum:adc1:adc2:tac1:tac2:tac3");

   while (1) {
      in >> runType >> runNum >> blkCnt >> tuplNum >> scaler1 >> scaler2 >> scaler3 
	>> ramp1 >> ramp2 >> adc1 >> adc2 >> tac1 >> tac2 >> tac3 >> hrClock >> lrClock;
      if (!in.good()) break;
      if (nlines < 5) printf("runType=%2i, runNum=%2i, adc1=%8i adc2=%8i \n",
				runType,runNum,adc1,adc2);
      h1adc1->Fill( (float) adc1);
      h1adc2->Fill( (float) adc2);
      h2adc1v2->Fill( (float) adc1, (float) adc2 );
      if ( adc1 > 150 && adc1 < 350 ) h1adc1a->Fill( (float) adc1); // limited range
      if ( adc1 > 150 && adc1 < 350 ) h1adc2a->Fill( (float) adc2); // limited range
      hpr1v2->Fill( (float) adc1, (float) adc2);

      h1t1->Fill( (float) tac1);
      h1t1a->Fill( (float) tac1);
      h1t1b->Fill( (float) tac1);
      nlines++;
   }
   printf(" found %d lines \n",nlines);

   in.close();

   //f->Write();

   TCanvas* c1 = new TCanvas();
   c1->Divide(1,3);
   c1->cd(1); // upper left
   h1adc1.Draw();
   c1->cd(2); // upper right
   h1adc2.Draw();
   c1->cd(3);
   h2adc1v2.Draw();
   c1->Update();

   TCanvas* c2 = new TCanvas();
   c2->Divide(1,3);
   c2->cd(1); // upper left
   h1adc1a.Draw();
   c2->cd(2); // upper right
   h1adc2a.Draw();
   c2->cd(3);
   hpr1v2.Draw();
   c2->Update();

   TCanvas* c3 = new TCanvas();
   c3->Divide(1,3);
   c3->cd(1); // top
   gPad->SetLogy();
   h1t1.Draw();
   c3->cd(2); // middle
   h1t1a.Fit("gaus");
   h1t1a.Draw();
   c3->cd(3);
   g1 = new TF1("g1","gaus",9500,9900);
   h1t1b->Fit(g1,"R");
   h1t1b.Draw();
   c3->Update();

}

