#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/* use below to get rid of warning message */
void usleep(unsigned long usec);

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  /*int ret;	*/	/* return for CAMAC command*/
  int mPointer=0;	/* holder for FERA memory pointer returned */
  int lam=0;
  int ext;
  int branch=18;
  int crate1=4;
  int crate,slot,subad,function,qres;
  int iloop=0;  

  /* unsigned long CDATA,CDATA0,CDATA1,CDATA2,CDATA3; */

  int return_status = CAM_S_SUCCESS;
  /* data array returned by Camac Controler */
  /* unsigned short IntArray[10000]; 
   */
  unsigned short dataw[2]={0,0};
  unsigned short data16[32768];
  /* Jorway spec say max 16bit word dma transfer is 16100 */
  int cb[3];	/* camac control block 0=request_repeat_count 1=result_repeat_count
						2=lam id(not used)    3=dma type 0=Q-stop 1=single_word
                         */
  int i=0;
  int evLoop=0,evLoopMax=0, iWait=0, iPulse=0;
  /*
  unsigned short RAW;
  int numNoReads=25;
  float pulserDelay=0.0, pulserPeriod=0.0;
   */
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */
  
 	
 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    crate = 4;
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
    cccc(ext);
  /* crate initialize */
    cccz(ext);
  /* remove crate inhibit */
    ccci(ext,0);

  function=0;

  /******* issue pulse from 2323 GG channel A to make initial CLR to 4302 ****/
	slot=18;
	
	subad = 0;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(1,ext,dataw,&qres);
	printf("Reading Channel A programming word: %X Q=%d\n", dataw[0], qres);
	
	subad = 0;
	cdreg(&ext,branch,crate1,slot,subad);
	dataw[0]=0x0090;			/* set nonlatched 128 nsec pulse */
	cssa(17,ext,dataw,&qres);

	subad = 0;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(1,ext,dataw,&qres);
	printf("Readback Channel A programming word: %X Q=%d\n", dataw[0], qres);
	

	for ( iPulse=0; iPulse<1; iPulse++) {
		subad = 0;
		cdreg(&ext,branch,crate1,slot,subad);
		cssa(25,ext,dataw,&qres);
		printf("Issue pulse on Channel A Q=%d\n", qres);
		usleep(1000);
	}
	
	

	return 0;

  /***************** SET UP the LeCroy 4302 FERA memory ********************/

    printf("\n Initializing 4302 buffer memory");

    slot=15; 

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/
    printf(" (using slot=%d) ",slot);

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(26,ext,dataw,&qres);    /* Set 4302 to enable LAM*/

    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address */

    printf("\n Writing pattern  to all memory addresses.");
	/* 16385 causes address overflow */
	/* 16384 causes address overflow */
	/* 16383 OK  memory pointer reads back at  0x3FFF =  16383 */
    for(iloop=0; iloop<16383; iloop++){
      dataw[0]=iloop;
      cssa(16,ext,dataw,&qres);    /* Write ??? to all memory addresses */
    }

    /* Read 4302 memory address */
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(1,ext,&dataw[0],&qres);
    printf("\n Current pointer for 4302 = %X %d",dataw[0],dataw[0]);
    if ( ( dataw[0] & 0xC000 ) == 0xC000 ) {
	printf("\n Found pattern in pointer indicating 'address overflow'.");
	printf("\n Pointer after masking is %X %d", ( dataw[0] & 0x3FFF ), ( dataw[0] & 0x3FFF ));
    }

    dataw[0]=0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address again */

    cssa(10,ext,dataw,&qres);	/* Test and clear the LAM on 4302 */
    printf("\n 4302 Test and clear LAM qres = %d ", qres);

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
  if ( 1==0) {
    dataw[0]=0x3;
    cssa(17,ext,dataw,&qres);    /* Set 4302 ECL mode enabled */
  }

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);    /* Read mode */
    printf("\n 4302 buffer mode is = %X Q = %X",dataw[0],qres);

    printf("\n");

    printf("\n\n***** End of setup and configuration ******\n");

  /***************************************************************/
  /************************ END EVENT LOOP *********************/
  /***************************************************************/

    printf("\n\n***** End of DAQ *****\n\n");
    fprintf(stderr, "\n\n***** End of DAQ *****\n\n");

    return 0;
}
