#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/* use below to get rid of warning message */
void usleep(unsigned long usec);

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  /*int ret;	*/	/* return for CAMAC command*/
  int mPointer=0;	/* holder for FERA memory pointer returned */
  int lam=0;
  int ext;
  int branch=18;
  int crate1=4;
  crate1 = 5;
  int crate,slot,subad,function,qres;
  int iloop=0;  

  /* unsigned long CDATA,CDATA0,CDATA1,CDATA2,CDATA3; */

  int return_status = CAM_S_SUCCESS;
  /* data array returned by Camac Controler */
  /* unsigned short IntArray[10000]; 
   */
  unsigned short dataw[2]={0,0};
  unsigned short data16[32768];
  /* Jorway spec say max 16bit word dma transfer is 16100 */
  int cb[3];	/* camac control block 0=request_repeat_count 1=result_repeat_count
						2=lam id(not used)    3=dma type 0=Q-stop 1=single_word
                         */
  int i=0;
  int evLoop=0,evLoopMax=0, iWait=0;
  /*
  unsigned short RAW;
  int numNoReads=25;
  float pulserDelay=0.0, pulserPeriod=0.0;
   */
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */
  
 	
  /***************** OPEN DATA FILE ********************/

	/* File to save data */
    FILE *data_file;
    char file[20] = ("data/run_001.txt");
    char ctemp[4];
    int r;
    int run;

  /* get configuration information from user or a <redirected file. */
/*   printf("Enter Run Number:  ");
    scanf("%003i",&run);
 */
	run = 0;	/* force run 000 */
    printf("run = %d\n", run);
    sprintf( &ctemp[0], "%03i", run);
    for (r = 0; r<3; ++r) file[r+9]=ctemp[r];
    printf("file name = %s\n", file); 

  /* Truncate to zero length or create file for writing ascii data output*/
    data_file = fopen(file,"w");
    if ( data_file == NULL ) {
      printf("Failed to open an output file to write data!\n");
      return 2;}

	fprintf(stderr,"Enter number of Loops(0=>3): ");
	scanf("%d", &evLoopMax);
	if (evLoopMax == 0) evLoopMax=3;
	fprintf(stderr,"Enter wait on LAM time in msec(0=>100): ");
	scanf("%d", &iWait );
	if (iWait == 0) iWait = 100;
	iWait = iWait*1000;	/* convert to usec */

/*
    printf("Enter Number of NoReads allowed: ");
    scanf("%d",&numNoReads);
    printf("Enter pulserDelay: ");
    scanf("%f",&pulserDelay);
    printf("Enter pulserPeriod: ");
    scanf("%f",&pulserPeriod);

    printf("User requested numNoReads = %d\n", numNoReads);
    printf("User requested pulserDelay = %f\n", pulserDelay);
    printf("User requested pulserPeriod = %f\n", pulserPeriod);

    printf("TitleLine: CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", 
    run, numNoReads, pulserDelay, pulserPeriod);
    fprintf(data_file,"CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", 
    run, numNoReads, pulserDelay, pulserPeriod);

    */


 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate1,slot,subad);
  
  /* crate clear */
    cccc(ext);
  /* crate initialize */
    cccz(ext);
  /* remove crate inhibit */
    ccci(ext,0);

  function=0;


  /***************** SET UP the LeCroy 4302 FERA memory ********************/

    printf("\n Initializing 4302 buffer memory");

    slot=15; 

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/
    printf(" (using slot=%d) ",slot);

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(26,ext,dataw,&qres);    /* Set 4302 to enable LAM*/

    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address */

    printf("\n Writing pattern  to all memory addresses.");
	/* 16385 causes address overflow */
	/* 16384 causes address overflow */
	/* 16383 OK  memory pointer reads back at  0x3FFF =  16383 */
    for(iloop=0; iloop<16383; iloop++){
      dataw[0]=iloop;
      cssa(16,ext,dataw,&qres);    /* Write ??? to all memory addresses */
    }

    /* Read 4302 memory address */
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(1,ext,&dataw[0],&qres);
    printf("\n Current pointer for 4302 = %X %d",dataw[0],dataw[0]);
    if ( ( dataw[0] & 0xC000 ) == 0xC000 ) {
	printf("\n Found pattern in pointer indicating 'address overflow'.");
	printf("\n Pointer after masking is %X %d", ( dataw[0] & 0x3FFF ), ( dataw[0] & 0x3FFF ));
    }

    dataw[0]=0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address again */

    cssa(10,ext,dataw,&qres);	/* Test and clear the LAM on 4302 */
    printf("\n 4302 Test and clear LAM qres = %d ", qres);

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
  if ( 1==0) {
    dataw[0]=0x3;
    cssa(17,ext,dataw,&qres);    /* Set 4302 ECL mode enabled */
  }

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);    /* Read mode */
    printf("\n 4302 buffer mode is = %X Q = %X",dataw[0],qres);

    printf("\n");

    printf("\n\n***** End of setup and configuration ******\n");


  /***************************************************************/
  /**************** START EVENT(buffer full)  LOOP ***************/
  /***************************************************************/

  for ( evLoop=0; evLoop<evLoopMax; evLoop++ ) {

	fprintf(stderr,"At evLoop=%d lam=%d\n", evLoop, lam);
	lam = 1; /* force the lam */
    while ( lam == 0 ) {
       /* slot=15;subad=0;function=8; */	/* test lam status */
       slot=15;
	subad=0;function=10;	/* test lam and clear status */
       cdreg(&ext,branch,crate1,slot,subad);
       cssa(function,ext,dataw,&qres);
       lam = qres;
	fprintf(stderr, "Found LAM status as qres=%d lam=%d \n",qres,lam);
       if ( lam == 1 ) break;
       fprintf(stderr, " Waiting on LAM, sleep for %d msec\n", iWait/1000);
       usleep(iWait);	/* sleep for iWait microseconds */
    }
    lam = 0;	/* get ready for next loop */


    /* Set 4302 to CAMAC mode*/

    slot=15; 

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/

    /* Read 4302 memory address */
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(1,ext,&dataw[0],&qres);
    printf("\n Current pointer for 4302 = %X %d\n",dataw[0],dataw[0]);
    fprintf(stderr, "Read memory pointer in 4302 = %X %d\n",dataw[0],dataw[0]);
    mPointer = dataw[0];	/* save the memory point to set dma size */

    /* Set 4302 current memory address to 0 */
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to 0 */
    fprintf(stderr, "Set memory pointer in 4302  to 0 \n");

    for ( i=0; i< 32768; i++) data16[i]=0;	/* clear buffer to receive data from dma */

    /* do a 1 word read or dma of 4302 memory */

    int top = 0;
    if ( 1 == 0 ) {
	subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(0, ext, &dataw[0], &qres);
	printf("1st word in memory is %X %d \n", dataw[0], dataw[0]);
    } else {
	subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	if ( mPointer == 0 ) {
		printf("Found mPointer = %d, reset to 16100\n", mPointer);
		mPointer = 16100;
	}
	if (mPointer <= 16100 ) {
		cb[0]=mPointer; cb[1]=0; cb[2]=0; cb[3]=0;
	} else {
		cb[0]=16100; cb[1]=0; cb[2]=0; cb[3]=0;
	}
	fprintf(stderr, "Do 1st dma with cb = %d %d %d %d\n", cb[0],cb[1],cb[2],cb[3]);
	csubc(0, ext, data16, cb);
	printf("\n dma returns cb[1]=%d", cb[1]);
        fprintf(stderr, "1st dma complete cb = %d %d %d %d\n", cb[0],cb[1],cb[2],cb[3]);
	top = cb[1];
	if (top > 16384 ) {
		fprintf(stderr,"Bad max value reset top = 16384\n");
		top = 16384;
	}
	for ( i=0; i<top; i++) {
		if ( (data16[i] & 0x8000) == 0x8000 ) {
			/* printf("\n i=%d data16[%d]= %x %d possible header.", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d header", i, data16[i],data16[i]);
		}
		else {
			/* printf("\n i=%d data16[%d]= %x %d", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d", i,data16[i],data16[i]);
		}
		fprintf(data_file, "%d %x %d\n", i,data16[i],data16[i]);
	}
    }

    if ( top == 16100 ) {
	/* attempt to readout remainder of buffer */
       /* Set 4302 current memory address to start at 16100 */
       subad=0;
       cdreg(&ext,branch,crate1,slot,subad);
       dataw[0]=16100;
       cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to end of last dma */

        for ( i=0; i< 32768; i++) data16[i]=0;	/* clear buffer to receive data from dma */
	subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	cb[0]=384; cb[1]=0; cb[2]=0; cb[3]=0;
	csubc(0, ext, data16, cb);
	printf("\n dma returns cb[1]=%d", cb[1]);
        fprintf(stderr, "2nd dma complete cb = %d %d %d %d\n", cb[0],cb[1],cb[2],cb[3]);
	int top = cb[1];
	if (top > 16384 ) top = 16384;

	for ( i=0; i<top; i++) {
		if ( (data16[i] & 0x8000) == 0x8000 ) /* start at 16100 */ {
			/* printf("\n i=%d data16[%d]= %x %d possible header.", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d header", i, data16[i],data16[i]);
		}
		else {
			/* printf("\n i=%d data16[%d]= %x %d", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d", i,data16[i],data16[i]);
		}
		fprintf(data_file, "%d %x %d\n", i,data16[i],data16[i]);
	} /* end of for ( */

   } /* end of if ( top == 16100 */

       slot=15;
	subad=0;function=10;	/* test and clear lam  */
       cdreg(&ext,branch,crate1,slot,subad);
       cssa(function,ext,dataw,&qres);

    /* Set 4302 current memory address to 0 */
    
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to 0 */


  } /* end of for ( evLoop */

  /***************************************************************/
  /************************ END EVENT LOOP *********************/
  /***************************************************************/

    printf("\n\n***** End of DAQ *****\n\n");
    fprintf(stderr, "\n\n***** End of DAQ *****\n\n");

    return 0;
}
